﻿#-*- coding:utf-8 -*
from speech import speak, speakSpelling
from controlTypes import ROLE_TABLEROW, ROLE_TREEVIEWITEM
from scriptHandler import  getLastScriptRepeatCount
from NVDAObjects.IAccessible import IAccessible
from ui import message
from wx import CallLater
from api import copyToClip
from .. import utils
from time import time
class MessageListItemFields (IAccessible):
	fields ="correspondentCol,senderCol,recipientCol,subjectCol,attachmentCol,sizeCol,dateCol,receivedCol,priorityCol,junkStatusCol,tagsCol,threadCol,flaggedCol,unreadButtonColHeader,statusCol,accountCol,unreadCol,totalCol,locationCol,idCol".split (",")
	notField ="Aucun champ texte"
	lastScriptKeyName=""
	chrono = False
	def getLabelMailAddress (self,s):
		t = self.appModule.regExp_mailAddress.sub (" ",s)
		return (s[:s.index ("@")] if  t.isspace ()else t).strip (u" '\"~#*&")

	def initOverlayClass (self):
		for e in range (1,10): self.bindGestures ({"kb:"+str (e):"readField","kb:alt+"+str (e):"readField"})
	def readField_default  (self, currentScriptKeyName, keyRepeat):
		index =int (currentScriptKeyName[-1])+(9 if  currentScriptKeyName[0].isalpha () else 0)
		if index > len (self.appModule.columnID) : return message (self.notField)
		o =self.getChild (index-1);name, columnText  =o.name, o.columnHeaderText
		if not keyRepeat : return speak ("{columnText}  {name}".format (columnText = columnText, name =name), symbolLevel =0)
		speak (u"{columnText} copié dans le presse papier".format (columnText =columnText), symbolLevel =0)
		copyToClip (u""+name)
	def clickCell (self,obj,field):
		description = obj.description
		if utils.getIA2Attribute (obj,"threadCol"):  description = u"File de discussion " +(u"Masquées",u"Affichées")[self.role == ROLE_TABLEROW]
		self.appModule.sort_modeChanged   =([description,field] if field else description )
		obj.doAction ()
		if field in ("threadCol","unreadButtonColHeader","junkStatusCol"): field =False
		#update 
		o=self
		while o and not "id" in o.IA2Attributes.keys ():o=o.container 
		self.appModule.buildColumnID (o)
	def script_readField(self,gesture):
		index, cols, i, options, currentScriptKeyName, lastScriptRepeatCount = int (gesture.mainKeyName)+len (gesture.modifierNames)*9, self.appModule.columnID,-1, self.appModule.options["messengerWindow"], gesture.displayName, getLastScriptRepeatCount ()
		if not self.appModule.date_firstMessage :self.appModule.date_firstMessage ="oui"
		if index >len (cols):index-=9
		elif not cols :return message (u"aucune en tête ")
		if not cols[0] in self.fields : return self.readField_default (currentScriptKeyName, lastScriptRepeatCount )
		if index <=0 or index >len (cols) :return  message ("aucun champ text")
		for e in range (len (self.fields)):
			if self.fields[e] in cols :
				i+=1
				if i == index-1: break
		else:
			return message (self.notField)
		field= self.fields[e]
		index = cols.index (field)
		self.lastCellCalledAndTime =[index,time (),field]
		o = self.getChild (index)
		if not o :return message (_("Ce champ n'est plus disponible "))
		value, columnHeaderText, columnHeaderText_original, add_doublePoint  =o.name, o.columnHeaderText,o.columnHeaderText, " : "
		if value in self.appModule.columnID : value =""
		#if  field =="subjectCol": value = (value [1:-1] if value.startswith ("[") and value.endswith ("]") or value.startswith ("{") and value.endswith ("}") else value )
		if field in  "correspondentCol,recipientCol,subjectCol, senderCol" and options.as_bool ("listGroupName"):value =self.appModule.regExp_nameListGroup.sub (" ",value)

		if field in ("correspondentCol","senderCol","recipientCol")  and options.as_bool ("mailAddress") :  value =self.getLabelMailAddress (value)
		if field == "subjectCol" : 
			value =self.appModule.regExp_AnnotationResponse.sub (" ",value)
		if field in ("receivedCol","dateCol") and options["dateExtended"] : value = utils.formatDateTime(value)
		if field =="threadCol":
			value = _(u"Les fil de discussion sont {state}").format (state = (u"Affichée",u"Masquée")[self.role == ROLE_TABLEROW])
			columnHeaderText, add_doublePoint ="",""
		elif field =="junkStatusCol":value ={"0":"acceptable","100":u"indésirable"}.get (value, "inconnu ");columnHeaderText="status "
		elif field == "flaggedCol" and value :
			value ="oui"
		elif field =="unreadCol" :value =("non","oui")[bool (value)]
		elif field =="unreadButtonColHeader" : 
			value = "message "+{False : columnHeaderText}.get (bool (value),value)
			add_doublePoint, columnHeaderText=""," "
		elif  field  =="attachmentCol" and value :
				columnHeaderText, value ="", self.getAttachment()
		elif value in ("priorityCol","subjectCol") :value =""
		if value :
			s =u"{columnHeaderText} {value}".format (columnHeaderText = columnHeaderText, value= value)
		else:
			s= u"Pas de {columnHeaderText}".format (columnHeaderText= columnHeaderText)
		o= self
		while o and not "id" in o.IA2Attributes.keys () :o=o.container
		o=o.firstChild.getChild (index)
		value =value.strip ()

		#action
		o =self
		while o and not utils.getIA2Attribute (o): o = o.container
		x=(e for e in o.firstChild.children)
		for o in x :
			if utils.getIA2Attribute (o,field) :break
		self.lastCellCalledAndTime.append (o)
		lastScriptRepeatCount = (lastScriptRepeatCount  if  lastScriptRepeatCount and self.lastScriptKeyName == currentScriptKeyName else 0)
		self.lastScriptKeyName = currentScriptKeyName
		if not lastScriptRepeatCount : return speak  ([s], symbolLevel =0)
		if  self.chrono :self.chrono.Stop ()
		self.chrono =CallLater (150,self.copyOrSpell, columnHeaderText_original,value, lastScriptRepeatCount )
	def copyOrSpell (self,columnHeaderText_original , value, lastScriptRepeatCount ):
		if lastScriptRepeatCount ==1 :speakSpelling (value)
		else:
			if copyToClip  (unicode (value)): 
				message (_(u"%s copié dans le presse papier ") %  columnHeaderText_original)
			else:
				message (_(u"le champ %s n'a pas pu être copié dans le presse papier ") % columnHeaderText_original)
	def script_space (self,gesture):
		if hasattr (self,"readContentMail"):
			if hasattr (self,"lastCellCalledAndTime")and time ()-self.lastCellCalledAndTime[1]<=0.6 :
				return self.clickCell (self.lastCellCalledAndTime[-1],self.lastCellCalledAndTime[-2])
			else:
				return self.readContentMail(gesture)
		gesture.send ()
	def script_shiftSpace (self,gesture):
		if hasattr (self,"readContentMail"):
			self.readContentMail(gesture)
		else:gesture.send ()



	__gestures={
"kb:space":"space",
		"kb:shift+space":"shiftSpace"
}
