﻿#https://msdn.microsoft.com/en-us/library/windows/desktop/ee671195(v=vs.85).aspx
#coding:utf-8
from globalCommands import GlobalCommands
from controlTypes import  ROLE_TAB
from ..utils import getIA2Attribute
from controlTypes import ROLE_TAB
from oleacc import STATE_SYSTEM_SELECTABLE, STATE_SYSTEM_SELECTED, STATE_SYSTEM_FOCUSABLE, STATE_SYSTEM_VALID
from wx import Menu, EVT_MENU,CallAfter,ITEM_CHECK, MenuItem
from ..utils import showNVDAMenu 
from NVDAObjects.IAccessible import IAccessible
from api import getForegroundObject
from UIAHandler import handler, UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ,UIA_TabControlTypeId, TreeScope_Descendants ,TreeScope_Children, IUIAutomationLegacyIAccessiblePattern, UIA_LegacyIAccessibleStatePropertyId, UIA_TreeControlTypeId ,UIA_TableControlTypeId,UIA_ListControlTypeId 
from ui import message
class PageTab (IAccessible):
	def initOverlayClass (self):
		if self.role == ROLE_TAB  :
			c =self.container 
			if self.appModule.currentFrame in "NostalgyPreferences printPageSetupDialog" or hasattr(c,"IA2Attributes") and "id" in c.IA2Attributes and  c.IA2Attributes["id"] !="view-tabs" : self.keyboardShortcut= "control+%s" % getIA2Attribute (self,attribute_name="posinset")

	def getObjPageTab (self, ct): return ct.ElementFromHandle(getForegroundObject ().windowHandle).FindFirst (TreeScope_Descendants,ct.CreatePropertyCondition (UIA_ControlTypePropertyId,UIA_TabControlTypeId ))

	def script_activePageTab (self,gesture):
		ct =handler.clientObject
		pageTab =self.getObjPageTab (ct)
		if not pageTab : return  gesture.send ()
		pageTabItem =pageTab.FindAll(TreeScope_Children,ct.CreatePropertyCondition (UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ))
		count,mainKeyName = pageTabItem.Length,(9 if gesture.mainKeyName =="0" else (int (gesture.mainKeyName)-1))
		if mainKeyName >=count : return message (_(u"Pas d'onglet au niveau %s") % (mainKeyName+1))
		pageTabItem =pageTabItem.GetElement (mainKeyName)
		newName =pageTabItem.CurrentName
		if self.role != ROLE_TAB and self.appModule.currentFrame =="messengerWindow":message (_(u"onglet %s") % newName)
		pageTabItem.GetCurrentPattern (10018).QueryInterface(IUIAutomationLegacyIAccessiblePattern).DoDefaultAction ()
	def script_showPageTabItemOnMenu (self,gesture):
		ct =handler.clientObject
		pageTab =self.getObjPageTab (ct)
		if not pageTab :return gesture.send ()
		self.pageTabItem =pageTab.FindAll (TreeScope_Children, ct.CreatePropertyCondition (UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ))
		mainMenu =Menu ()
		for e in range (self.pageTabItem.Length):
			element =self.pageTabItem.GetElement (e)
			menuitem =MenuItem (mainMenu,e+1,element.CurrentName+"\tControl+%s" % (e+1 if e!=10 else 0),kind =ITEM_CHECK)
			state=bool (element.GetCurrentPropertyValue (UIA_LegacyIAccessibleStatePropertyId )&STATE_SYSTEM_SELECTED)
			menuitem.Check(state)
			menuitem.Enable (not state)
			mainMenu.AppendItem (menuitem)
		mainMenu.Bind (EVT_MENU, self.onMenu_pageTab)
		showNVDAMenu (mainMenu)
	def onMenu_pageTab (self,evt):
		CallAfter (self.pageTabItem.GetElement (evt.Id-1).GetCurrentPattern (10018).QueryInterface(IUIAutomationLegacyIAccessiblePattern).DoDefaultAction )
	def getCurrentPageName (self):
		if self.role == ROLE_TAB and self.hasFocus:return self.name
		ct =handler.clientObject
		c= ct.CreateAndCondition (ct.CreatePropertyCondition (UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ),ct.CreatePropertyCondition (30096 ,STATE_SYSTEM_SELECTABLE| STATE_SYSTEM_SELECTED| STATE_SYSTEM_FOCUSABLE))
		try:
			item =self.getObjPageTab (ct).FindFirst (TreeScope_Children, c)
		except:return False
		return (False if not item else item.CurrentName)
	def script_title (self, gesture):
		GlobalCommands().script_title (gesture)
		if self.appModule.currentFrame == "messengerWindow": return 
		pageName =self.getCurrentPageName ()
		if pageName :message (_(u"dans l'onglet %s") % pageName)
	__gestures ={
		"kb:nvda+t":"title",
		"kb:control+1":"activePageTab",
		"kb:control+2":"activePageTab",
		"kb:control+3":"activePageTab",
		"kb:control+4":"activePageTab",
		"kb:control+5":"activePageTab",
		"kb:control+6":"activePageTab",
		"kb:control+7":"activePageTab",
		"kb:control+8":"activePageTab",
		"kb:control+9":"activePageTab",
		"kb:control+0":"activePageTab"}
