﻿# coding : utf-8
from ..utils import getIA2Attribute,showNVDAMenu 
from NVDAObjects.IAccessible import IAccessible
import controlTypes
from speech import speakSpelling
from ui import message
from scriptHandler import getLastScriptRepeatCount
from winsound import MessageBeep
from config import conf
from wx import CallLater,CallAfter ,Menu,EVT_MENU,ITEM_CHECK
from tones import beep 
def b (): beep (500,500)
class Nostalgy (IAccessible):
	chrono =None
	keyEnterPressed =False
	def initOverlayClass (self):
		role =self.role

		if role ==controlTypes.ROLE_COMBOBOX :
			self.name ="nostalgy"
			self.role = controlTypes.ROLE_DIALOG
			self.states.clear ()
			self.states.add (controlTypes.STATE_FOCUSED)
			return 
		if role == controlTypes.ROLE_LISTITEM :
			option =self.appModule.options["nostalgy"]["itemText_display"]
			option =(0 if option =="False" else int (option))
			if option :
				name =self.name.split ("/")
				if option==2 :name.reverse ()
				self.name =(u"{0}, {1}".format (name[(-1 if option ==1 else 0)],("/").join ((name[:-1]if option ==1  else name[1:])))).strip ().strip (",")
			self.bindGestures ({"kb:end":"goItemExtrem","kb:home":"goItemExtrem","kb:downarrow":"verticalArrow","kb:uparrow":"verticalArrow"})
		elif role ==controlTypes.ROLE_EDITABLETEXT :
			self.name =self.nameEdit
			self.bindGestures({"kb:downArrow":"shiftTab","kb:upArrow":"shiftTab"})
	def event_valueChange (self):
		if not self.hasFocus :return 
		if self.chrono :self.chrono.Stop ()
		self.chrono =CallLater (200,self.reportResultOfSearch )
		super (Nostalgy ,self).event_valueChange ()
	def reportResultOfSearch (self):
		o, reportObjectPositionInformation  = self.next, conf["presentation"]["reportObjectPositionInformation"]
		if not o or not o.next or  o.next.childCount <2:
			if not self.keyEnterPressed  : MessageBeep ()
			return 
		o=o.next.getChild (1)
		if not o or not o.name or  not "indexInGroup" in o.positionInfo.keys () : return 
		o.name =(o.name if not o.name.count ("/") else o.name.split ("/")[-1])
		o.positionInfo ={"similarItemsInGroup":o.positionInfo["similarItemsInGroup"],"indexInGroup":o.positionInfo["indexInGroup"]}
		if not controlTypes.STATE_SELECTED  in o.states :o.states.add (controlTypes.STATE_SELECTED)
		conf["presentation"]["reportObjectPositionInformation"]=True
		o.reportFocus ()
		conf["presentation"]["reportObjectPositionInformation"]=reportObjectPositionInformation
	def _get_nameEdit (self):
		name =self.parent.previous.name
		return {"Go to folder:":_(u"Aller au dossier:"),
"Move messages to:":_(u"Déplacer le message vers :"),
"Move messages and go to:":_(u"déplacer le message et aller à :"),
"Copy messages to:":_(u"Copier le message vers :")
}.get (name,name)

	def script_goItemExtrem (self,gesture):
		if self.parent.childCount <=2 :return 
		action =gesture.mainKeyName =="end"
		((self.parent.getChild(2),self.parent.lastChild.previous)[action]).setFocus ()
		gesture.fromName (("uparrow","downarrow")[action]).send ()
	def script_verticalArrow (self,gesture):
		mainKeyName =gesture.mainKeyName
		if  (mainKeyName =="upArrow" and not self.previous.previous )or (mainKeyName =="downArrow" and not self.next) : 
			self.reportFocus()
			return MessageBeep ()
		gesture.send ()
	def script_shiftTab (self,gesture):
		role =self.role
		if role == controlTypes.ROLE_LISTITEM : return self.parent.parent.doAction ()
		elif role == controlTypes.ROLE_EDITABLETEXT and not self.next.next :MessageBeep ()
		gesture.send ()
	def script_title (self,gesture):
		message ("Nostalgy")
	def script_readStatusBarText (self,gesture):
		o=self
		while o and not getIA2Attribute (o,"nostalgy-folderbox"):o=o.container
		if not o :return message (_(u"barre d'état non trouvée"))
		o,text =o.firstChild.next, _(u"Aucune occurence trouvée")
		if o.next and o.next.childCount>=2:
			text =_(u"%d occurences trouvées") % (o.next.childCount-1)
		(message if not getLastScriptRepeatCount () else speakSpelling )(text)
	def script_enter (self,gesture):
		self.appModule.messengerWindow_type ="mailContent"

		self.keyEnterPressed =True
		self.sleepMode =True
		#pour éviter un bug récurrent je ne déplace pas le focus 

		if self.role ==controlTypes.ROLE_EDITABLETEXT  and self.next and self.next.next and self.childCount >=2 :return self.next.next.getChild (1).doAction ()
		gesture.send ()
	def script_escape (self,gesture):
		self.appModule.messengerWindow_type ="mailContent"

		self.sleepMode =True
		gesture.send ()
	def script_showMenu (self,gesture):
		itemText =_(u"Affichage par défaut,afficher le nom du dossier puis le chemin, afficher le nom du dossier et inverser le chemin").split (",")
		menu =Menu ()
		for (a,b) in enumerate (itemText): menu.Append (a,b, kind=ITEM_CHECK)
		option =self.appModule.options["nostalgy"]["itemText_display"]
		option =(0 if option =="False" else int (option))
		menu.FindItemById(option ).Check (True )
		menu.Bind (EVT_MENU,self.onMenu)
		showNVDAMenu (menu)
	def onMenu (self,evt):
		self.appModule.options["nostalgy"]["itemText_display"]=evt.Id
		self.appModule.options.write ()

	__gestures ={"kb:nvda+t":"title",
		"kb:enter":"enter",
		"kb:nvda+end":"readStatusBarText" ,
"kb:tab":"shiftTab",
"kb:escape":"escape"}
